function [A,Va]   = ConstructA_M(M3,M2,projectA)
% constructs the quadratic moments, uses network weights as inputs (M2=lag,
% M3=current)
%M2 is period one or lagged network matrix
%M3 is the current network matrix

n = size(M3,1);


A1 = (M2 + M2')/2;
if projectA
   A2 = (M2'*M2);    
else
   A2 = (M2'*M2) - diag(diag((M2'*M2)),0);
end

if isempty(M2)
    A3  = (M3 + M3');
    if projectA
       A4  = (M3'*M3); 
    else
       A4  = (M3'*M3) - diag(diag((M3'*M3)),0);
    end
else
    A3  = (M3 + M3')/2; 
    if projectA
       A4  = (M3'*M3); 
    else
       A4  = (M3'*M3) - diag(diag((M3'*M3)),0); 
    end
end



if isempty(M2)
    A  = [vec(A3);vec(A4)];
    Ar = [vec(A3),vec(A4)];
else
    A  = [vec(A1);vec(A2);vec(A3);vec(A4)];
    Ar = [vec(A1),vec(A2),vec(A3),vec(A4)];
end

rf = 4;
if rank(Ar)<4
   A  = [vec(A2);vec(A3);vec(A4)];
   A1 = zeros(size(M3));
   rf = 3;
   if rank(Ar)<3
       A  = [vec(A3);vec(A4)];
       A2 = zeros(size(M3));
       rf = 2;
       if rank(Ar)<2
           A  = vec(A4);
           A3 = zeros(size(M3));
           rf = 1;
       end
   end
end

Va = zeros(rf,rf);

for i=1:n
    for j=1:n
        if rf     == 4
                  Vai = [A1(i,j);A2(i,j);A3(i,j);A4(i,j)];
        elseif rf ==3
                  Vai = [A2(i,j);A3(i,j);A4(i,j)];
        elseif rf ==2
                  Vai = [A3(i,j);A4(i,j)];
        elseif rf ==1
                  Vai = A4(i,j);                  
        end
        Va  = Va + Vai*Vai';
    end
end

Va = Va/n;
if rf == 1
   Va = [[zeros(3,3),zeros(3,1)];[zeros(1,3),Va]];
   A  = [zeros(3*n^2,1);A]; 
elseif rf == 2
   Va = [[zeros(2,2),zeros(2,2)];[zeros(2,2),Va]];
   A  = [zeros(2*n^2,1);A];
elseif rf == 3
   Va = [[zeros(1,1),zeros(1,3)];[zeros(3,1),Va]];
   A  = [zeros(n^2,1);A];
else %full rank case - do nothing
% Do nothing
end

return
