function sigma = EstimateSigma(y_plus,W1_plus,W2_plus,lambda_hat,beta_hat,f,Tin)
% Computes the variance of the error terms in each period

T          = size(y_plus,2);
n          = size(y_plus,1);
sigma      = zeros(T,1);
sigma(T,1) = 1;


n1      = size(W1_plus,1);
n2      = size(W2_plus,1);

if mod(n1,n)==0
    dim1 = n1/n;
else
    error('Dimension error EstimateSigma');
end
if mod(n2,n)==0
    dim2 = n2/n;
else
    error('Dimension error EstimateSigma');
end

if dim1 > size(lambda_hat,1) % handle case where W1 contains more variables than just My
   ddim       = dim1 - size(lambda_hat,1);
   lambda_hat = [lambda_hat;beta_hat(1:ddim,1)];
   beta_hat   = beta_hat(ddim+1:end,:);
end

u_plus = zeros(n,T);

for t = T-1:-1:1
    u_plus(:,t) = y_plus(:,t) - reshape(W1_plus(:,t),n,dim1)*lambda_hat - reshape(W2_plus(:,t),n,dim2)*beta_hat;   
    sigma(t,1)  = u_plus(:,t)'*u_plus(:,t)/(n*f(t)^2) - sigma(t+1,1);
    if sigma(t,1)<=0
       sigma(t,1) = sigma(t+1,1);
    end
end

if Tin > T % for dynamic model adjust sample size
    sigma = [ones(Tin-T,1);sigma];
end
end

