function [lambda_hat,beta_hat,lambda_first,beta_first] = Estimator_GMMFixed( y,Z,H,M,AmF,VmF,dynamic,n,T )
% GMM estimator for models with fixed factors (f=1) that are not estimated

sigma      = ones(T,1);
f          = ones(T,1);
[y_plus,~,~,~,W1_plus,W2_plus,~,~]= ForwardDiff(y,Z,M,sigma,dynamic);


QindTemp = true;
Qind     = false;
projectA = false;
efficient= true;

[A,P,Q,V]= formatAPQV(W2_plus,H,AmF,VmF,dynamic,projectA,QindTemp,n,T);


lambda0    = zeros(3,1);
[lambda_hat,beta_hat] = FixedFactorLinQuadGMM(A,P,Q,V,y_plus,W1_plus,W2_plus,lambda0,dynamic);

if ~Qind
    [A,~,Q,V]= formatAPQV(W2_plus,H,AmF,VmF,dynamic,projectA,Qind,n,T);
end

lambda_first = lambda_hat;
beta_first   = beta_hat;

if efficient
    sigma                              = EstimateSigma(y_plus,W1_plus,W2_plus,lambda_hat,beta_hat,f,T);
    [y_plus,~,~,~,W1_plus,W2_plus,~]    = ForwardDiff(y,Z,M,sigma,dynamic);
end

if T<=5
    Iterations        = 'full';
else
    Iterations        = 'one';
end
[lambda_hat,beta_hat] = FullLinQuadGMMFixedF(A,Q,V,y_plus,W1_plus,W2_plus,H,[lambda_hat;beta_hat],Iterations);
end

