function [delta,F] = Estimator_IV( yplus,Myplus,Wplus,H,n,T )
%Two stage least squares (2SLS) estimated on differenced data

dimW            = size(Wplus,1)/n;
dimH            = size(H,1)/n;
y               = zeros(n*T,1);
My              = zeros(n*T,1);
W               = zeros(n*T,dimW);
h               = zeros(n*T,dimH*T);
hr              = zeros(n*T,2*T);

for t=1:T
    y((t-1)*n+1:t*n,1)                    = yplus(:,t);
    W((t-1)*n+1:t*n,:)                    = reshape(Wplus(:,t),n,dimW);
    h((t-1)*n+1:t*n,(t-1)*dimH+1:dimH*t)  = reshape(H(:,t),n,dimH);
    hr((t-1)*n+1:t*n,(t-1)*2+1:2*t)       = h((t-1)*n+1:t*n,(t-1)*dimH+1:(t-1)*dimH+2); %only use included instruments
    My((t-1)*n+1:t*n,:)                   = Myplus(:,t);
end


Ph          = (h/(h'*h))*h';
Phr         = (hr/(hr'*hr))*hr';

k           = size(h,2);
g           = size(hr,2);


Qh          = eye(T*n) - Ph;
Qhr         = eye(T*n) - Phr;
F           = My'*(Qhr - Qh)*My/(My'*Qh*My)*(T*n-k)/g;

delta       = (W'*Ph*W)\(W'*Ph*y);

end

