function [lambda_hat,beta_hat] = FullLinQuadGMM(A,Q,V,y,Z,M,h,f,sigma,lambda0,Iterations,dynamic)

n  = size(y,1);
T  = size(y,2);

if dynamic
    W1 = zeros(n,T);
    W2 = zeros(2*n,T);    
else
    W1 = zeros(n,T);
    W2 = zeros(2*n,T);
end

%build up covariate matices
if dynamic 
    lb = 2;
else
    lb = 1;
end
dimpar = 3;
for t = T:-1:lb
   if dynamic 
       W1(:,t) = reshape(M(:,t),n,n)*y(:,t);
       W2(:,t) = [y(:,t-1);reshape(M(:,t),n,n)*y(:,t-1)];      
   else
       W1(:,t) = reshape(M(:,t),n,n)*y(:,t);
       W2(:,t) = [Z(:,t);reshape(M(:,t),n,n)*Z(:,t)];      
       
   end       
end

param = [lambda0;f(1:end-1,1)];

[ ulam,ulamh,ulamQ,hh,n,T ] = FullOptimDataPrepFlexFactor( y,W1,W2,h,A,Q,dynamic );

% find minimizers of concentrated quadratic criterion

oldoptions = optimoptions(@fminunc); %save old options
switch Iterations
    case 'one'
        options        = optimoptions(@fminunc,'Algorithm','quasi-newton','MaxIterations',1,'Display','off'); % reduce Iterations to just one
        try 
            [param,~]  = fminunc(@(param)mlq(param,dimpar,ulam,ulamh,ulamQ,hh,V,sigma,dynamic,n,T),param,options);
        catch
            param      = lambda0;
        end        
    case 'full'
        options        = optimoptions(@fminunc,'Algorithm','quasi-newton','MaxIterations',100,'Display','off');
        try 
            [param,~]  = fminunc(@(param)mlq(param,dimpar,ulam,ulamh,ulamQ,hh,V,sigma,dynamic,n,T),param,options);
        catch
            param      = lambda0;
        end
end
        

lambda_hat = param(1,1);
beta_hat   = param(2:3,1);

optimoptions(@fminunc,oldoptions);

return