function [ ulam,ulamh,ulamQ,hh,n,T ] = FullOptimDataPrep( y_plus,W1_plus,W2_plus,h,A,Q )
% computes sufficient statistics for criterion function

n         = size(y_plus,1);
T         = size(y_plus,2);
numI      = size(h,1)/n;


n1      = size(W1_plus,1);
n2      = size(W2_plus,1);


if mod(n1,n)==0
    dim1 = n1/n;
else
    error('Dimension error mlqFixedF');
end
if mod(n2,n)==0
    dim2 = n2/n;
else
    error('Dimension error mlqFixedF');
end

ulamh     = zeros(T,numI*(1+dim1+dim2));
ulam      = zeros(n*T,1+dim1+dim2);
ulamQ     = zeros(n*T,(1+dim1+dim2)*4);
hh        = zeros(numI^2,T);


%first unpackW quadratic weight matrices
At        = reshape(A(:,T),n^2,4);
At1       = reshape(At(:,1),n,n);
At2       = reshape(At(:,2),n,n);
At3       = reshape(At(:,3),n,n);
At4       = reshape(At(:,4),n,n);
hT        = reshape(h(:,T),n,numI);

QT        = reshape(Q(:,T),n,n);


ulam((T-1)*n+1:T*n,:)      = [y_plus(:,T),-reshape(W1_plus(:,T),n,dim1),- reshape(W2_plus(:,T),n,dim2)];
ulamh(T,:)                 = vec(ulam((T-1)*n+1:T*n,:)'*hT)';
hh(:,T)                    = vec(hT'*hT);

if rank(At1)==0 && rank(At2)~=0 && rank(At3)~=0
    ulamQ((T-1)*n+1:T*n,:)   = [zeros(n,4),QT*At2*QT*ulam((T-1)*n+1:T*n,:),...
                                QT*At3*QT*ulam((T-1)*n+1:T*n,:),...
                                QT*At4*QT*ulam((T-1)*n+1:T*n,:)];
elseif rank(At1)==0 && rank(At2)==0 && rank(At3)~=0
    ulamQ((T-1)*n+1:T*n,:)   = [zeros(n,8),QT*At3*QT*ulam((T-1)*n+1:T*n,:),...
                                QT*At4*QT*ulam((T-1)*n+1:T*n,:)];
elseif rank(At1)==0 && rank(At2)==0 && rank(At3)==0
    ulamQ((T-1)*n+1:T*n,:)   = [zeros(n,12),QT*At4*QT*ulam((T-1)*n+1:T*n,:)];
else
    ulamQ((T-1)*n+1:T*n,:)   = [QT*At1*QT*ulam((T-1)*n+1:T*n,:),...
                                QT*At2*QT*ulam((T-1)*n+1:T*n,:),...
                                QT*At3*QT*ulam((T-1)*n+1:T*n,:),...
                                QT*At4*QT*ulam((T-1)*n+1:T*n,:)];
end


for t = T-1:-1:1
    At        = reshape(A(:,t),n^2,4);
    At1       = reshape(At(:,1),n,n);
    At2       = reshape(At(:,2),n,n);
    At3       = reshape(At(:,3),n,n);
    At4       = reshape(At(:,4),n,n); 
    Qt        = reshape(Q(:,t),n,n);
    ht        = reshape(h(:,t),n,numI);
    
    ulam((t-1)*n+1:t*n,:)           = [y_plus(:,t), - reshape(W1_plus(:,t),n,dim1), - reshape(W2_plus(:,t),n,dim2)];
    ulamh(t,:)                      = vec(ulam((t-1)*n+1:t*n,:)'*ht)';
    hh(:,t)                         = vec(ht'*ht);
    
    if rank(At1)==0 && rank(At2)~=0 && rank(At3)~=0
        ulamQ((t-1)*n+1:t*n,:)   = [zeros(n,3),Qt*At2*Qt*ulam((t-1)*n+1:t*n,:),...
                                    Qt*At3*Qt*ulam((t-1)*n+1:t*n,:),...
                                    Qt*At4*Qt*ulam((t-1)*n+1:t*n,:)];
    elseif rank(At1)==0 && rank(At2)==0 && rank(At3)~=0
        ulamQ((t-1)*n+1:t*n,:)   = [zeros(n,6),Qt*At3*Qt*ulam((t-1)*n+1:t*n,:),...
                                     Qt*At4*Qt*ulam((t-1)*n+1:t*n,:)];
    elseif rank(At1)==0 && rank(At2)==0 && rank(At3)==0
        ulamQ((t-1)*n+1:t*n,:)   = [zeros(n,9),Qt*At4*Qt*ulam((t-1)*n+1:t*n,:)];
    else
        ulamQ((t-1)*n+1:t*n,:)   = [Qt*At1*Qt*ulam((t-1)*n+1:t*n,:),...
                                    Qt*At2*Qt*ulam((t-1)*n+1:t*n,:),...
                                    Qt*At3*Qt*ulam((t-1)*n+1:t*n,:),...
                                    Qt*At4*Qt*ulam((t-1)*n+1:t*n,:)];
    end
end

end

