%main Loop
tic
clear;
NumSim = 1000;

% define structure of parameter values that control DGP
Param.azeta     = -1;
Param.a0        = 1;
Param.kappa     = 20;
Param.kappax    = 10;
Param.xi        = .75;
Param.xid       = 1;
Param.xil       = 1;
Param.ku        = 1;
Param.ka        = 10;
Param.d         = 1;
Param.delta_1   = 0.05;
Param.delta_2   = 0.1;
Param.beta1     = ones(Param.d,1)*0;   % static model if beta1 = 0
Param.beta2     = 0;                   % for static model set beta2=0 
Param.beta3     = 1;                   % no exongenous covs if beta3=0
Param.beta4     = 1;                   % no exogeneous peer effects Mz if beta4 = 0
Param.gamma     = 1;                   % controls if M is endogenous or not 0=exogenous
Param.factors   = false;               % controls if the model has factors
Param.efficient = false;
Param.endogenous= false;               % controls what type of instruments are used in quadratic moments
Param.factoralph= 0;
Param.factorsig = 0;
Param.zetadep   = 1;
Param.zetasig   = 0;
Param.mu_gam    = 0;
Param.T         = 2;
Param.sigmav    = sqrt(1);             % variance of innovation
Param.staticM   = true;
Param.appMe     = 'smooth';            % determines how M is approximated 'smooth','binary' or 'random'
Param.projectA  = false;               % determines if A matrix is projected onto ortho complement of H for quadratic moments


Param.T         = 2;

Filename        = 'Results_GMM_MEndogenous_12b_T2_n';

Param.n         = []; % sample size
lambda_list     = [.1,.3,.5,.7];        % parameter values for network interaction
localToNonID    = [1,.5,.1];            % parameter that controls identification of linear IV
amu_list        = -.1;                  % network endogeneity parameter
n_list          = [100,250,500];


efficient       = true;

SimulationMainLoop(Param,NumSim,lambda_list,localToNonID,amu_list,n_list,efficient,Filename)

                  

