classdef ResultClassDefinitions <handle
    % This class sets up storage for simulation results, provides a
    % listener and iteration count to store results and functions to
    % evaluate and report summary statistics after simulations are carried
    % out.
    properties
        MSE   = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                       'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);
        MAE   = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                       'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);
        Bias  = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                       'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);
        Med   = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                       'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);
        FSR2  = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                       'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);
		mEig  = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                       'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);
        Iteration = 0;
        RMSE   = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                        'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);                    
        AMAE   = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                        'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);        
        ABias  = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                        'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);        
        AMed   = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                        'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);                
        AFSR2  = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                        'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);
		AmEig  = struct('OLS',[],'IV',[],'IVA',[],'IV1',[],'IV2',[],'GMM',[],'GMM1',[],'GMM2',[],...
                        'GMMNEFM',[],'GMM_EFFM',[],'GMM_EFFM1',[],'GMM_EFFM2',[],'GMMNEFAppM',[],'GMM_EFFAppM',[]);
        Outputfilename;
        Outputfilename1;
        Outputfilename2;
        Outputfilename2A;
        Outputfilename3;
    end
    methods 
        function Results = ResultClassDefinitions(NumSim,outfn,firstIni,Param) % function to construct class
            if firstIni
                     Results.Outputfilename1  = strcat(outfn,"_Lambda.txt");
                     Results.Outputfilename2  = strcat(outfn,"_Beta1.txt");
                     Results.Outputfilename2A = strcat(outfn,"_Beta1A.txt");
                     Results.Outputfilename3  = strcat(outfn,"_Beta2.txt");
                     dlmwrite(Results.Outputfilename1,[],'delimiter','');
                     dlmwrite(Results.Outputfilename2,[],'delimiter','');
                     dlmwrite(Results.Outputfilename2A,[],'delimiter','');
                     dlmwrite(Results.Outputfilename3,[],'delimiter','');
                     Results.Iteration = 0;
                     s = ['%%% azeta = ' num2str(Param.azeta) ', a0 = ' num2str(Param.a0) ', kappa = ' num2str(Param.kappa)...
                         ', xi = ' num2str(Param.xi) ', xid = ' num2str(Param.xid) ', xil = ' num2str(Param.xil) ...
                         ', ku = ' num2str(Param.ku) ', ka  = ' num2str(Param.ka) ', d = ' num2str(Param.d)...
                         ', delta1 = ' num2str(Param.delta_1) ', delta_2 = ' num2str(Param.delta_2) ', beta1 = ' num2str(Param.beta1)...
                         ', beta2 = ' num2str(Param.beta2) ', beta3 = ' num2str(Param.beta3) ', beta4 = ' num2str(Param.beta4)...
                         ', gamma = ' num2str(Param.gamma) ', factors = ' num2str(Param.factors) ', efficient = ' num2str(Param.efficient)...
                         ', endogenous = ' num2str(Param.endogenous) ', zetadep ' num2str(Param.zetadep) ', zetasig = ' num2str(Param.zetasig)...
                         ', facalph = ' num2str(Param.factoralph) ', facsig = ' num2str(Param.factorsig) ', mu_gam = ' num2str(Param.mu_gam)...
                         ',sigmav = ' num2str(Param.sigmav) ',staticM = ' num2str(Param.staticM) ', T = ' num2str(Param.T)];
                     dlmwrite(Results.Outputfilename1,s,'-append','delimiter','');
                     dlmwrite(Results.Outputfilename2,s,'-append','delimiter','');
                     dlmwrite(Results.Outputfilename2A,s,'-append','delimiter','');                     
                     dlmwrite(Results.Outputfilename3,s,'-append','delimiter','');

            else
                     Results.Outputfilename1  = strcat(outfn,"_Lambda.txt");
                     Results.Outputfilename2  = strcat(outfn,"_Beta1.txt");
                     Results.Outputfilename2A = strcat(outfn,"_Beta1A.txt");                     
                     Results.Outputfilename3  = strcat(outfn,"_Beta2.txt");
                     Results.Iteration = 0;
            end
            Results = ResultsInitialize(Results,NumSim);			
        end
        function RS = StoreResults(Results)
                 RS = Results;
        end
        function ySim = CompMSE(Results,ySim,it)
            type           = ySim.Param.type;
            fe1            = ySim.lambda - ySim.Param.lambda;
            if ySim.dynamic
                fe2            = ySim.beta(1,1) - ySim.Param.beta1;
                fe3            = ySim.beta(2,1) - ySim.Param.beta2;
            else
                fe2            = ySim.beta(1,1) - ySim.Param.beta3;
                fe3            = ySim.beta(2,1) - ySim.Param.beta4;
            end
                
            if it
               Results.Iteration = Results.Iteration + 1; %increment iteration counter 
            end
               Results  = StoreResultsMSE(Results,ySim,type,fe1,fe2,fe3);
        end
        function Results = AveMSEA(Results,Param)
            Results = AverageResults(Results);
            PrintResultsAveMSEA(Results,Param);                        
        end
        function Results = AveMSE(Results,Param)
            Results = AverageResults(Results);
            PrintResultsAveMSE(Results,Param);                        
        end        
        function Results = AveMSEInstComp(Results,Param)
            Results = AverageResults(Results);
            PrintResultsAveMSEInstComp(Results,Param);                        
        end
        function Results = AveMSEMain(Results,Param)
            Results = AverageResults(Results);
            PrintResultsAveMSEMain(Results,Param);                        
        end        
        function Results = AveMSEMain_Endo(Results,Param)
            Results = AverageResults(Results);
            PrintResultsAveMSEMain_Endo(Results,Param);                        
        end        
        function Results = AveMSEInstCompEndoM(Results,Param)
            Results = AverageResults(Results);
            PrintResultsAveMSEInstCompEndoM(Results,Param);                        
        end   
        function Results = AveMSE_Factor(Results,Param)
            Results = AverageResults(Results);
            PrintResultsAveMSE_Factor(Results,Param);                        
        end        
        function Results = AveMSE_ExoEndoM(Results,Param)
            Results = AverageResults(Results);
            PrintResultsAveMSE_ExoEndoM(Results,Param);                        
        end        
    end
 end
