classdef SimulateGrahamFactor < DataClassDefinitions
    methods
        function yA = SimulateGrahamFactor(Param)

            yA         = yA@DataClassDefinitions(Param);            
            
            staticM    = yA.Param.staticM;
            if staticM                     % if M is static reset all dynamic and endogeneity parameters to zero
                yA.Param.gamma   = 0;
                yA.Param.delta_1 = 0;
                yA.Param.delta_2 = 0;
            end
            
            yB = GenerateGrahamData(yA.Param);
            
            yA.yplusDat   = yB.yplusDat;
            yA.yMplusDat  = yB.yMplusDat;
            yA.yMLplusDat = yB.yMLplusDat;
            yA.yDat       = yB.yDat;
            yA.zetaDat    = yB.zetaDat;
            yA.ZDat       = yB.ZDat;
            yA.AmFDat     = yB.AmFDat;
            yA.AmFstarDat = yB.AmFstarDat;
            yA.MDat       = yB.MDat;
            yA.MstarDat   = yB.MstarDat;
            yA.VmFDat     = yB.VmFDat;
            yA.VmFstarDat = yB.VmFstarDat;
            yA.DDat       = yB.DDat;
            yA.WplusDat   = yB.WplusDat;
            yA.W1plusDat  = yB.W1plusDat;
            yA.W2plusDat  = yB.W2plusDat;
            yA.ZplusDat   = yB.ZplusDat;
            yA.zplusDat   = yB.zplusDat;
            yA.MZplusDat  = yB.MZplusDat;
            yA.HDat       = yB.HDat;
            yA.H1Dat      = yB.H1Dat;
            yA.H2Dat      = yB.H2Dat;
            yA.HADat      = yB.HADat;
            
            yA.HstarDat   = yB.HstarDat;            
            yA.H1starDat  = yB.H1starDat;
            yA.H2starDat  = yB.H2starDat;
            
            yA.HdynDat    = yB.HdynDat;
            yA.HAdynDat   = yB.HAdynDat;
            yA.HstardynDat= yB.HstardynDat;
            
            yA.Hdyn1Dat    = yB.Hdyn1Dat;
            yA.HAdyn1Dat   = yB.HAdyn1Dat;
            yA.Hstardyn1Dat= yB.Hstardyn1Dat;
            
            yA.Hdyn2Dat    = yB.Hdyn2Dat;
            yA.HAdyn2Dat   = yB.HAdyn2Dat;
            yA.Hstardyn2Dat= yB.Hstardyn2Dat;
            
            yA.dynamic    = yB.dynamic;
        end
    end
end
