function SimulationMainLoop(Param,NumSim,lambda_list,localToNonID,amu_list,n_list,efficient,Filename)

factors         = Param.factors;
dynamic         = (Param.beta1 ~=0);
endogenous      = Param.endogenous;

tic
Itcount = 0;
% Start Simulation Loop
for in = 1:length(n_list)
    Param.n  = n_list(in);
    outfn_NonF      = [Filename num2str(Param.n)];

    outfnData       = ['SimulationData_' Filename num2str(Param.n)];
    
    % Initialize Output files
    if Param.factors
        Results      = ResultClassDefinitions(NumSim,outfn_NonF,true,Param);
    else
        ResultsNonF  = ResultClassDefinitions(NumSim,outfn_NonF,true,Param);
    end

    for i3 = 1:length(amu_list)
        Param.amu = amu_list(i3);
        for i1 = 1:length(lambda_list)
            Param.lambda = lambda_list(i1);
            for i2 = 1:length(localToNonID)
                Param.LocalID  = localToNonID(i2);
                if dynamic
                   Param.beta2 = - Param.lambda + localToNonID(i2);
                else
                   Param.beta4 = - Param.lambda + localToNonID(i2);
                end
                if factors                    
                      Results      = ResultClassDefinitions(NumSim,outfn_NonF,false);
                else
                    ResultsNonF    = ResultClassDefinitions(NumSim,outfn_NonF,false);
                end

                rng(0);            % Initialize random number generators for predictable rndn sequences
                for i=1:NumSim
                    disp([outfn_NonF '  : ' num2str(i)]);
                    y = SimulateGrahamFactor(Param); % generates data object with randomly drawn samples Goldsmith Imbens model
                    if factors                                      
                        y.OLS;
                        Results.CompMSE(y,true);
                        InstrumentType = 1;
                        y.IV(InstrumentType,endogenous);
                        Results.CompMSE(y,false);
                        InstrumentType = 2;
                        y.IV(InstrumentType,endogenous);
                        Results.CompMSE(y,false);

                        InstrumentType = 1;
                        y.GMM_Simplified_Modified(InstrumentType);
                        Results.CompMSE(y,false);
                        InstrumentType = 2;
                        y.GMM_Simplified_Modified(InstrumentType);
                        Results.CompMSE(y,false);

                    else
                        y.OLS;
                        ResultsNonF.CompMSE(y,true);
                        endogenous = false;
                       

                        if (Param.beta1 ~= 0) && (Param.gamma == 0)
                           % estimate dynamic model with exogenous M
                           dynamic   = true;
                           InstrumentType = 1;

                           y.IV(InstrumentType,endogenous);
                           ResultsNonF.CompMSE(y,false);
                           InstrumentType = 2;
                           y.IV(InstrumentType,endogenous);
                           ResultsNonF.CompMSE(y,false);

                           InstrumentType = 1;
                           
                           y.GMMFixedF(efficient,dynamic,InstrumentType,endogenous); % estimate dyanmic model
                           ResultsNonF.CompMSE(y,false); 
                           
                           InstrumentType = 2;
                           y.GMMFixedF(efficient,dynamic,InstrumentType,endogenous); % estimate dyanmic model
                           ResultsNonF.CompMSE(y,false); 
                           
                        elseif (Param.beta1 ==0) && (Param.gamma == 0)
                           % estimate static model with exogenous M
                           dynamic   = false;

                           InstrumentType = 1;
                           y.IV(InstrumentType,endogenous);
                           ResultsNonF.CompMSE(y,false);
                           InstrumentType = 2;
                           y.IV(InstrumentType,endogenous);
                           ResultsNonF.CompMSE(y,false);
                           

                           InstrumentType = 1;
                           y.GMMFixedF(efficient,dynamic,InstrumentType,endogenous);  % estimate static model
                           ResultsNonF.CompMSE(y,false); 
                           
                           InstrumentType = 2;
                           y.GMMFixedF(efficient,dynamic,InstrumentType,endogenous);  % estimate static model
                           ResultsNonF.CompMSE(y,false); 
                           
                        elseif (Param.beta1 ==0) && (Param.gamma ~= 0)
                           % estimate static model with endogenous M
                           dynamic     = false;
                          
                           InstrumentType = 1;
                           endogenous  = true;
                           y.IV(InstrumentType,endogenous);
                           ResultsNonF.CompMSE(y,false);
                           
                           InstrumentType = 2;
                           endogenous  = true;                           
                           y.IV(InstrumentType,endogenous);
                           ResultsNonF.CompMSE(y,false);
                           
                         
                           endogenous = true; % use approximated M
                           InstrumentType = 1;                           
                           y.GMMFixedF(efficient,dynamic,InstrumentType,endogenous);  % estimate static model
                           ResultsNonF.CompMSE(y,false); 
                           
                           endogenous = true; % use approximated M
                           InstrumentType = 2;
                           y.GMMFixedF(efficient,dynamic,InstrumentType,endogenous);  % estimate static model
                           ResultsNonF.CompMSE(y,false);                           
                        end
                    end
                end
                Itcount = Itcount + 1;
                if factors
                    Results.AveMSEInstComp(Param);
                    ResultStore(Itcount) = Results.StoreResults;
                elseif ~factors && ~endogenous                    
                    ResultsNonF.AveMSEInstComp(Param);
                    ResultStore(Itcount) = ResultsNonF.StoreResults;
                elseif ~factors && endogenous                    
                    ResultsNonF.AveMSEInstCompEndoM(Param);
                    ResultStore(Itcount) = ResultsNonF.StoreResults;
                end   
             end
        end
    end
    %Save simulation Data and open files for next sample size
    save(outfnData,'ResultStore');
    Itcount         = 0;
    clear('ResultStore');
end
toc
