function SimulationMainLoopOptComp(Param,NumSim,lambda_list,localToNonID,amu_list,n_list,~,Filename)

factors         = Param.factors;
dynamic         = (Param.beta1 ~=0);
endogenous      = Param.endogenous;

tic
Itcount = 0;
% Start Simulation Loop
for in = 1:length(n_list)
    Param.n  = n_list(in);
    outfn_NonF      = [Filename num2str(Param.n)];
    outfnData       = ['SimulationData_' Filename num2str(Param.n)];
    
    % Initialize Output files
    if Param.factors
        Results      = ResultClassDefinitions(NumSim,outfn_NonF,true,Param);
    else
        ResultsNonF  = ResultClassDefinitions(NumSim,outfn_NonF,true,Param);
    end

    for i3 = 1:length(amu_list)
        Param.amu = amu_list(i3);
        for i1 = 1:length(lambda_list)
            Param.lambda = lambda_list(i1);
            for i2 = 1:length(localToNonID)
                Param.LocalID  = localToNonID(i2);
                if dynamic
                   Param.beta2 = - Param.lambda + localToNonID(i2);
                else
                   Param.beta4 = - Param.lambda + localToNonID(i2);
                end
       
       
                if factors                    
                      Results      = ResultClassDefinitions(NumSim,outfn_NonF,false);
                else
                    ResultsNonF    = ResultClassDefinitions(NumSim,outfn_NonF,false);
                end

                rng(0);            % Initialize random number generators for predictable rndn sequences
                for i=1:NumSim
                    disp([outfn_NonF '  : ' num2str(i)]);
                    y = SimulateGrahamFactor(Param); % generates data object with randomly drawn samples Goldsmith Imbens model
                    if factors     
                        tic
                        y.OLS;
                        Results.CompMSE(y,true);
                        InstrumentType = 1;
                        y.IV(InstrumentType,endogenous);
                        Results.CompMSE(y,false);
                        InstrumentType = 2;
                        y.IV(InstrumentType,endogenous);
                        Results.CompMSE(y,false);

                        InstrumentType = 1;
                        y.GMM_OptComp(InstrumentType);
                        Results.CompMSE(y,false);
                        y.Param.type = 'GMM_EFFM2';     %manually override type
                        y.lambda     = y.lambda_first;  %manually recover estimates from one step procedure
                        y.beta       = y.beta_first;    %manually recover estimates from one step procedure
                        Results.CompMSE(y,false);       %recompute results for one step results
                        toc
                    end
                end
                Itcount = Itcount + 1;
                if factors
                    Results.AveMSEInstComp(Param);
                    ResultStore(Itcount) = Results.StoreResults;
                elseif ~factors && ~endogenous                    
                    ResultsNonF.AveMSEInstComp(Param);
                    ResultStore(Itcount) = ResultsNonF.StoreResults;
                elseif ~factors && endogenous                    
                    ResultsNonF.AveMSEInstCompEndoM(Param);
                    ResultStore(Itcount) = ResultsNonF.StoreResults;
                end   
             end
        end
    end
    %Save simulation Data and open files for next sample size
    save(outfnData,'ResultStore');
    Itcount         = 0;
    clear('ResultStore');
end
toc
