function [ ulamQ,Va ] = cleanQuadMom(ulamQ,V,param)
% Removes redundant quadratic moment conditions

p     = size(param,1)+1;   %number of parameters + 1
d     = size(ulamQ,2);
T     = size(V,2);
dimV  = sqrt(size(V,1));

numQ  = d/p;               %number of quadratic moments

r     = rank(ulamQ);

if r > rank(ulamQ(:,d-r+1:d))
    ulamQ = ulamQ(:,d-8+1:d);
    numQd = numQ - 2;          %number of redundant quadratic moments
else
    ulamQ = ulamQ(:,d-r+1:d);
    numQd = numQ - r/p;        %number of redundant quadratic moments
end



Va    = zeros((numQ-numQd)^2,T);


if dimV>r
    for t=1:T
        Vt    = reshape(V(:,t),dimV,dimV);
        Vt    = Vt(numQd+1:end,numQd+1:end);
        Va    = vec(Vt);
    end
else
        Va    = V;
end
end

