function h = eliminateRedH(hIn)
%Eliminates multicolinear columns in the instrument matrix
%   hIn n*T x dimH dimensional matrix with dimH instruments observed at T
%   times


dimH  = size(hIn,2);
rH    = rank(hIn);
h     = zeros(size(hIn,1),rH);

if rH<3
    error('Insufficient instruments in H');
end

ch    = 0;
rold  = 0;
for i=1:dimH    
    r = rank(hIn(:,1:i));
    if r == rold + 1 % column i is not orthogonal to previoius columns - use in h
        ch = ch + 1;
        h(:,ch) = hIn(:,i);
        rold    = r;
    else
        % do nothing
    end
end
        

end

