function cr = mlqFixedF(param,ulam,ulamh,ulamQ,hh,V,n,T)
%compute linar quadratic criterion function at parameter value

d              = size(param,1);
numI           = size(ulamh,2)/(1+d); %number of linear moments
kq             = size(ulamQ,2)/(1+d); %number of quadratic moments
ulamQp         = zeros(n*T,kq);
dimV           = sqrt(size(V,1));


param          = [1;param];

crl  = 0;
crq  = 0;

for t=1:T
    ulamht          = reshape(ulamh(t,:),(d+1),numI)';
    crl             = crl + (ulamht*param)'/(reshape(hh(:,t),numI,numI)) * (ulamht * param);

    for i=1:kq
        ulamQp((t-1)*n+1:t*n,i) = ulamQ((t-1)*n+1:t*n,(i-1)*(1+d)+1:i*(1+d))*param;
    end
    V1              = reshape(V(:,t),dimV,dimV);
    V1              = V1(dimV-kq+1:end,dimV-kq+1:end);
    crq1            = ulamQp((t-1)*n+1:t*n,:)'*ulam((t-1)*n+1:t*n,:)*param;
    crq             = crq + crq1' / (V1) * crq1;
end

cr  = crl + 1/(2*n) * crq;

return

